import { useContextProps as M, useRenderProps as g, Provider as S } from "./ui-components-library121.js";
import { OverlayTriggerStateContext as c } from "./ui-components-library47.js";
import { mergeProps as E } from "./ui-components-library125.js";
import { mergeRefs as A } from "./ui-components-library139.js";
import { filterDOMProps as O } from "./ui-components-library126.js";
import { useObjectRef as p } from "./ui-components-library140.js";
import { useViewportSize as I } from "./ui-components-library174.js";
import { useExitAnimation as x, useEnterAnimation as v } from "./ui-components-library175.js";
import o, { forwardRef as R, useContext as m, createContext as y, useRef as N, useMemo as T } from "react";
import { useOverlayTriggerState as _ } from "./ui-components-library176.js";
import { useIsSSR as w } from "./ui-components-library177.js";
import { DismissButton as B } from "./ui-components-library178.js";
import { useModalOverlay as L } from "./ui-components-library179.js";
import { Overlay as U } from "./ui-components-library180.js";
const K = /* @__PURE__ */ y(null), u = /* @__PURE__ */ y(null), ie = /* @__PURE__ */ R(function(e, a) {
  if (m(u)) return /* @__PURE__ */ o.createElement(b, {
    ...e,
    modalRef: a
  }, e.children);
  let { isDismissable: i, isKeyboardDismissDisabled: s, isOpen: l, defaultOpen: n, onOpenChange: f, children: d, isEntering: $, isExiting: C, UNSTABLE_portalContainer: h, shouldCloseOnInteractOutside: D, ...P } = e;
  return /* @__PURE__ */ o.createElement(z, {
    isDismissable: i,
    isKeyboardDismissDisabled: s,
    isOpen: l,
    defaultOpen: n,
    onOpenChange: f,
    isEntering: $,
    isExiting: C,
    UNSTABLE_portalContainer: h,
    shouldCloseOnInteractOutside: D
  }, /* @__PURE__ */ o.createElement(b, {
    ...P,
    modalRef: a
  }, d));
});
function j(t, e) {
  [t, e] = M(t, e, K);
  let a = m(c), r = _(t), i = t.isOpen != null || t.defaultOpen != null || !a ? r : a, s = p(e), l = N(null), n = x(s, i.isOpen), f = x(l, i.isOpen), d = n || f || t.isExiting || !1, $ = w();
  return !i.isOpen && !d || $ ? null : /* @__PURE__ */ o.createElement(F, {
    ...t,
    state: i,
    isExiting: d,
    overlayRef: s,
    modalRef: l
  });
}
const z = /* @__PURE__ */ R(j);
function F({ UNSTABLE_portalContainer: t, ...e }) {
  let a = e.modalRef, { state: r } = e, { modalProps: i, underlayProps: s } = L(e, r, a), l = v(e.overlayRef) || e.isEntering || !1, n = g({
    ...e,
    defaultClassName: "react-aria-ModalOverlay",
    values: {
      isEntering: l,
      isExiting: e.isExiting,
      state: r
    }
  }), f = I(), d = {
    ...n.style,
    "--visual-viewport-height": f.height + "px"
  };
  return /* @__PURE__ */ o.createElement(U, {
    isExiting: e.isExiting,
    portalContainer: t
  }, /* @__PURE__ */ o.createElement("div", {
    ...E(O(e), s),
    ...n,
    style: d,
    ref: e.overlayRef,
    "data-entering": l || void 0,
    "data-exiting": e.isExiting || void 0
  }, /* @__PURE__ */ o.createElement(S, {
    values: [
      [
        u,
        {
          modalProps: i,
          modalRef: a,
          isExiting: e.isExiting,
          isDismissable: e.isDismissable
        }
      ],
      [
        c,
        r
      ]
    ]
  }, n.children)));
}
function b(t) {
  let { modalProps: e, modalRef: a, isExiting: r, isDismissable: i } = m(u), s = m(c), l = T(() => A(t.modalRef, a), [
    t.modalRef,
    a
  ]), n = p(l), f = v(n), d = g({
    ...t,
    defaultClassName: "react-aria-Modal",
    values: {
      isEntering: f,
      isExiting: r,
      state: s
    }
  });
  return /* @__PURE__ */ o.createElement("div", {
    ...E(O(t), e),
    ...d,
    ref: n,
    "data-entering": f || void 0,
    "data-exiting": r || void 0
  }, i && /* @__PURE__ */ o.createElement(B, {
    onDismiss: s.close
  }), d.children);
}
export {
  ie as Modal,
  K as ModalContext,
  z as ModalOverlay
};
