import { ButtonContext as F } from "./ui-components-library43.js";
import { useContextProps as R, useSlottedContext as h, useSlot as D, removeDataAttributes as g, useRenderProps as M, Provider as _ } from "./ui-components-library121.js";
import { FieldErrorContext as q } from "./ui-components-library51.js";
import { FormContext as E } from "./ui-components-library138.js";
import { GroupContext as I } from "./ui-components-library64.js";
import { InputContext as S } from "./ui-components-library65.js";
import { LabelContext as V } from "./ui-components-library49.js";
import { TextContext as y } from "./ui-components-library67.js";
import { filterDOMProps as L } from "./ui-components-library126.js";
import i, { forwardRef as O, createContext as s, useRef as w } from "react";
import { useLocale as A } from "./ui-components-library132.js";
import { useNumberFieldState as G } from "./ui-components-library181.js";
import { useNumberField as T } from "./ui-components-library182.js";
const j = /* @__PURE__ */ s(null), k = /* @__PURE__ */ s(null), oe = /* @__PURE__ */ O(function(e, a) {
  [e, a] = R(e, a, j);
  let { validationBehavior: c } = h(E) || {};
  var r, o;
  let l = (o = (r = e.validationBehavior) !== null && r !== void 0 ? r : c) !== null && o !== void 0 ? o : "native", { locale: $ } = A(), t = G({
    ...e,
    locale: $,
    validationBehavior: l
  }), f = w(null), [b, u] = D(!e["aria-label"] && !e["aria-labelledby"]), { labelProps: m, groupProps: p, inputProps: x, incrementButtonProps: v, decrementButtonProps: P, descriptionProps: C, errorMessageProps: B, ...d } = T({
    ...g(e),
    label: u,
    validationBehavior: l
  }, t, f), N = M({
    ...e,
    values: {
      state: t,
      isDisabled: e.isDisabled || !1,
      isInvalid: d.isInvalid || !1,
      isRequired: e.isRequired || !1
    },
    defaultClassName: "react-aria-NumberField"
  }), n = L(e);
  return delete n.id, /* @__PURE__ */ i.createElement(_, {
    values: [
      [
        k,
        t
      ],
      [
        I,
        p
      ],
      [
        S,
        {
          ...x,
          ref: f
        }
      ],
      [
        V,
        {
          ...m,
          ref: b
        }
      ],
      [
        F,
        {
          slots: {
            increment: v,
            decrement: P
          }
        }
      ],
      [
        y,
        {
          slots: {
            description: C,
            errorMessage: B
          }
        }
      ],
      [
        q,
        d
      ]
    ]
  }, /* @__PURE__ */ i.createElement("div", {
    ...n,
    ...N,
    ref: a,
    slot: e.slot || void 0,
    "data-disabled": e.isDisabled || void 0,
    "data-required": e.isRequired || void 0,
    "data-invalid": d.isInvalid || void 0
  }), e.name && /* @__PURE__ */ i.createElement("input", {
    type: "hidden",
    name: e.name,
    value: isNaN(t.numberValue) ? "" : t.numberValue
  }));
});
export {
  oe as NumberField,
  j as NumberFieldContext,
  k as NumberFieldStateContext
};
